	.macro	struct	name
xyzzy	.assigna	0
	.endm


	.macro	varray	name,size
\name	.equ		\&xyzzy
xyzzy	.assigna	\&xyzzy+\size
	.endm



	.macro	vud	name
\name	.equ		\&xyzzy
xyzzy	.assigna	\&xyzzy+1
	.endm

	.macro	vumat	name
\name	.equ		\&xyzzy
xyzzy	.assigna	\&xyzzy+4
	.endm


	.macro	endst	name
\name	.equ		\&xyzzy
xyzzy	.assigna	\&xyzzy+1
	.endm


	.macro	vua	name,size
\name	.equ		\&xyzzy
xyzzy	.assigna	\&xyzzy+\size
	.endm

	.macro	getCONSTlri
	rinit		r,vf00x
	rget		ONE,r
	mfir		ZERO,vi00
	loi		-1
	muli		mONE,ONE,i
	.endm

	.macro	getCONSTu
	maxw		ONE,vf00,vf00
	sub		ZERO,vf00,vf00
	sub		mONE,ZERO,ONE
	.endm

	.macro	getONEl
	rinit	r,vf00x
	rget	ONE,R
     ;	maxw	ONE,vf00,vf00
	.endm

	.macro	getONEu
   maxw	ONE,vf00,vf00
	.endm

	.macro	dotx	dot,vc0,vc1
	mul.xyz	tmp\@,\vc0,\vc1
	adday.x	acc,tmp\@,tmp\@
	maddz.x	\dot,ONE,tmp\@
	.endm

	.macro	doty	dot,vc0,vc1
	mul.xyz	tmp\@,\vc0,\vc1
	addaz.y	acc,tmp\@,tmp\@
	maddx.y	\dot,ONE,tmp\@
	.endm


	.macro	dotz	dot,vc0,vc1
	mul.xyz	tmp\@,\vc0,\vc1
	adday.z	acc,tmp\@,tmp\@
	maddx.z	\dot,ONE,tmp\@
	.endm

	.macro	normalise_q	norm,vec
	mul.xyz	tmp,\vec,\vec
	adday.x	acc,tmp,tmp
	maddz.x	tmp,ONE,tmp
	rsqrt		q,vf00w,tmpx
	mulq.xyz	\norm,\vec,q   		; norm is normal in dof
	.endm

	.macro	normalise_p	norm,vec
	mul.xyz	tmp,\vec,\vec
	adday.x	acc,tmp,tmp
	maddz.x	tmp,ONE,tmp
	ersqrt 	p,tmpx
	mfp.w		rcpsq,p
	mulw.xyz	\norm,\vec,rcpsq   		; norm is normal in dof
	.endm
	

	.macro	loixyzw	reg,xval,yval,zval,wval
	loi		\xval
	addi.x	\reg,vf00,i

	loi		\yval
	addi.y	\reg,vf00,i

	loi		\zval
	addi.z	\reg,vf00,i

	loi		\wval
	muli.w	\reg,vf00,i
	.endm

	.macro	loix	reg,val
	loi	\val
	addi.x	\reg,vf00,i
	.endm

 	.macro	loiy	reg,val
	loi	\val
	addi.y	\reg,vf00,i
	.endm

 	.macro	loiz	reg,val
	loi	\val
	addi.z	\reg,vf00,i
	.endm

 	.macro	loiw	reg,val
	loi	\val
	muli.w	\reg,vf00,i
	.endm

	.macro	loixyz	reg,xval,yval,zval
	loix		\reg,\xval
	loiy		\reg,\yval
	loiz		\reg,\zval
	.endm


	.macro	loixy	reg,xval,yval
	loix		\reg,\xval
	loiy		\reg,\yval
	.endm

	.macro	isetu	reg,val
	iaddiu	\reg,vi00,\val
	.endm

	.macro	iset		reg,val
	iaddi		\reg,vi00,\val
	.endm

	.macro	izero		reg
	isub		\reg,vi00,vi00
	.endm

	.macro	vzero		reg
	sub		\reg,vf00,vf00			; sets flags!
	.endm


	.macro	isetbig	reg,val
	iaddiu	\reg,vi00,0x7fff
	iaddiu	\reg,\reg,\val-0x7fff
	.endm


	.macro	vec_x_matX		nv,ov,mat
	mulaw		acc,\mat[3],vf00
	maddax 	acc,\mat[0],\ov
	madday 	acc,\mat[1],\ov
	maddz		\nv,\mat[2],\ov
	.endm

	; vector 4

	.macro	vec_x_mat	nv,ov,mat
	mulax		acc,\mat[0],\ov
	madday 	acc,\mat[1],\ov
	maddaz 	acc,\mat[2],\ov
	maddw		\nv,\mat[3],\ov
	.endm


	; nm= lm.rm

	.macro	mat_x_mat	nm,lm,rm

	mulax		acc,\rm[0],\lm[0]
	madday	acc,\rm[1],\lm[0]
	maddaz	acc,\rm[2],\lm[0]
	maddw		\nm[0],\rm[3],\lm[0]

	mulax		acc,\rm[0],\lm[1]
	madday	acc,\rm[1],\lm[1]
	maddaz	acc,\rm[2],\lm[1]
	maddw		\nm[1],\rm[3],\lm[1]

	mulax		acc,\rm[0],\lm[2]
	madday	acc,\rm[1],\lm[2]
	maddaz	acc,\rm[2],\lm[2]
	maddw		\nm[2],\rm[3],\lm[2]

	mulax		acc,\rm[0],\lm[3]
	madday	acc,\rm[1],\lm[3]
	maddaz	acc,\rm[2],\lm[3]
	maddw		\nm[3],\rm[3],\lm[3]

	.endm

	; cat matrix with local coord scale by val

	.macro	scaleMat_XYZi	mat,val
	loi		\val
	muli		\mat[0],\mat[0],i
	muli		\mat[1],\mat[1],i
	muli		\mat[2],\mat[2],i
	.endm


	
	.macro	imove	ir0,ir1
	iadd		\ir0,\ir1,vi00
	.endm


	.macro	idec	ir
	iaddi		\ir,\ir,-1
	.endm

	.macro	iinc	ir
	iaddi		\ir,\ir,1
	.endm

	
	.macro	ram_xyzw		mem,val0,val1,val2,val3
	
	loi		\val0
	addi.x	tmp,vf00,i

	loi		\val1
	addi.y	tmp,vf00,i
	
	loi		\val2
	addi.z	tmp,vf00,i
	
	loi		\val3
	muli.w	tmp,vf00,i
		
	sq			tmp,\mem

	.endm

