GS_TEXFLUSH		.equ	H'3f
GS_FRAME_1		.equ	H'4c
GS_ZBUF_1		.equ	H'4e
GS_SCIS_1		.equ	H'40
GS_COLCLAMP		.equ	H'46
GS_DTHE			.equ	H'45
GS_FBA_1			.equ	H'4a
GS_PABE			.equ	H'49
GS_PRMODECONT	.equ	H'1a
GS_SCANMSK   	.equ	H'22
GS_TEXA		 	.equ	H'3b
GS_CLAMP_1	 	.equ	H'08
GS_TEST_1 		.equ	H'47

GS_TEX0_1		.equ	H'6
GS_TEX1_1		.equ	H'14


DEMU_FB0			.equ	0
DEMU_FB1			.equ	70
DEMU_ZB			.equ	140

	.macro		gs_send_sync
	iaddiu		tmp\@,vi00,i_nopTag
		--barrier
	xgkick		tmp\@
		--barrier
	.endm


	.macro	gs_send_reg_init
	iaddiu	adTag_reg,vi00,i_a_dTag
	.endm


		.macro	gs_kick_addr 	addr
		iaddiu	tmp\@,vi00,\addr
	 	--barrier
		xgkick	tmp\@
	 	--barrier
	 	.endm


		.macro	gs_texflush
		iaddiu	tmp\@,vi00,GS_TEXFLUSH
		isw.z		tmp\@,i_a_dData(vi00)
		iaddiu	tmp\@,vi00,i_a_dTag
	 	--barrier
		xgkick	tmp\@
		--barrier
		.endm


	

		.macro	gs_sendreg_vf	gs_reg,reg
		iaddiu	tmp\@,vi00,\gs_reg
		isw.z		tmp\@,i_a_dData(vi00)z
		sq.xy		\reg,i_a_dData(vi00)
		--barrier
		xgkick	adTag_reg
		--barrier
		.endm


		.macro	gs_sendreg_vi	gs_reg,reg
		iaddiu	tmp\@,vi00,\gs_reg
		isw.z		tmp\@,i_a_dData(vi00)z
		isw.y		vi00,i_a_dData(vi00)y
		isw.x		\reg,i_a_dData(vi00)x
  		--barrier
  	xgkick	adTag_reg
  		--barrier
		.endm


		.macro	gs_sendreg_imm	gs_reg,imm
		iaddiu	tmp\@,vi00,\gs_reg
		isw.z		tmp\@,i_a_dData(vi00)z
		isw.y		vi00,i_a_dData(vi00)y
		iaddiu	tmp\@,vi00,\imm
		isw.x		tmp\@,i_a_dData(vi00)x
  		--barrier
		xgkick	adTag_reg
		--barrier
		.endm


