GS_TEXFLUSH		.equ	H'3f
GS_FRAME_1		.equ	H'4c
GS_ZBUF_1		.equ	H'4e
GS_SCIS_1		.equ	H'40
GS_COLCLAMP		.equ	H'46
GS_DTHE			.equ	H'45
GS_FBA_1			.equ	H'4a
GS_PABE			.equ	H'49
GS_PRMODECONT	.equ	H'1a
GS_SCANMSK   	.equ	H'22
GS_TEXA		 	.equ	H'3b
GS_CLAMP_1	 	.equ	H'08
GS_TEST_1 		.equ	H'47

GS_TEX0_1		.equ	H'6
GS_TEX1_1		.equ	H'14

DEMU_ZB			.equ	140




	.macro		gs_send_sync
	iaddiu		tmp\@,vi00,sp_nopTag
	--barrier
	xgkick		tmp\@
	--barrier
	.endm


	.macro	gs_sendreg_init
	iaddiu	adTag_reg,vi00,sp_a_dTag
	.endm


	.macro	gs_kick_addr 	addr
	iaddiu	tmp\@,vi00,\addr
	--barrier
	xgkick	tmp\@
	--barrier
	.endm



	.macro	gs_sendreg_i15	gs_reg,imm
	
	iaddiu	tmp\@,vi00,\gs_reg
	isw.z	tmp\@,sp_a_dData(vi00)
	iaddiu	tmp\@,vi00,\imm
	isw.x	tmp\@,sp_a_dData(vi00)
	isw.y	vi00,sp_a_dData(vi00)
	--barrier
	xgkick	adTag_reg
	--barrier
	gs_send_sync
	.endm

	.macro	gs_sendreg_long	gs_reg,sp_offset
	iaddiu	tmp\@,vi00,\gs_reg
	isw.z	tmp\@,sp_a_dData(vi00)z
	lq.xy	tmp\@,\sp_offset(vi00)
	sq.xy	tmp\@,sp_a_dData(vi00)
	--barrier
	xgkick	adTag_reg
	--barrier
	gs_send_sync
	.endm


