typedef struct mapseg_s
{
    float keypos1;
    float keypos2;
    int blenda;
    int blendb;
    int ring1a;
    int ring1b;
    int ring2a;
    int ring2b;
    int palettea;
    int paletteb;
    int basecola;
    int basecolb;
} mapseg;
#define pack4(a,b,c,d)	((a<<12)|(b<<8)|(c<<4)|(d<<0))
#define pack2(a,b)	((a<<8)|(b<<0))
#define blend(a,b,c,d,e,f,g,h)	pack4(a,b,c,d),pack4(e,f,g,h)
#define ring1(a,b,c,d,e,f,g,h)	pack4(a,b,c,d),pack4(e,f,g,h)
#define ring2(a,b,c,d,e,f,g,h)	pack4(a,b,c,d),pack4(e,f,g,h)
#define pal(a,b,c,d)	pack2(a,b),pack2(c,d)
#define basecol(a,b,c)	pack2(a,b),pack2(c,0)
mapseg mapdata[50]=
{
    {  0.0f,  0.0f, blend( 0, 0, 0, 0, 0, 0, 0, 0),
		    ring1(15,15,15,15,15,15,15,15),
		    ring2( 0, 0, 0, 0, 0, 0, 0, 0),
		      pal(   30,   34,   37,   32), basecol(255,127,0)},
    {  0.0f,  0.0f, blend( 2, 3, 2, 2, 3, 6, 4, 3),
		    ring1(15,15,15,15,15,15,15,15),
		    ring2( 2, 2, 2, 2, 6, 5, 6, 6),
		      pal(   36,   33,   39,   31), basecol(255,127,0)},
    {  0.0f,  0.0f, blend( 5, 4, 4, 3, 3, 8, 0, 0),
		    ring1(15,15,15,15,15,15, 5, 6),
		    ring2( 5, 2, 5, 6, 2, 6, 0, 0),
		      pal(   32,   37,   30,   69), basecol(255,127,0)},
    {  0.0f,  0.0f, blend( 0, 0, 5, 5, 6, 4, 5, 5),
		    ring1( 5, 6, 6, 5, 1, 1, 1, 0),
		    ring2( 0, 0, 0, 0, 5, 6, 0, 0),
		      pal(    0,    1,    2,    3), basecol(255,127,0)},
    {  0.0f,  0.0f, blend( 5, 5, 5, 5, 0, 0, 0, 0),
		    ring1( 0, 0, 0, 2, 2, 2, 2, 2),
		    ring2( 6, 6, 6, 5, 0, 0, 0, 0),
		      pal(    4,    5,    6,    7), basecol(255,0,0)},
    { 10.0f,  0.0f, blend( 0, 0, 0, 0, 0, 0, 0, 0),
		    ring1( 6, 2, 5, 6, 5, 2, 5, 6),
		    ring2( 0, 0, 0, 0, 0, 0, 0, 0),
		      pal(    8,    9,    0,    1), basecol(255,127,0)},
    { 20.0f,  5.0f, blend( 4, 6, 5,13, 4, 5, 6, 8),
		    ring1(11,11,11,11,11,11,11,11),
		    ring2( 1, 4, 4, 1, 3, 3, 1,10),
		      pal(    2,    3,    4,    5), basecol(255,255,0)},
    { 25.0f,  8.0f, blend( 4, 5, 6, 3, 2, 6, 4, 6),
		    ring1(10,10,10,10,10,10,10,10),
		    ring2( 9, 6, 5, 2, 5,14,11, 1),
		      pal(   30,   33,   31,   34), basecol(127,255,0)},
    { 40.0f,  0.0f, blend( 7, 1, 2, 3, 6, 8, 5, 2),
		    ring1(12,12,12,12,12,12,12,12),
		    ring2( 2, 6, 5, 6, 6, 2, 5, 6),
		      pal(   38,   35,   32,   39), basecol(0,255,0)},
    { 34.0f,  2.0f, blend( 0, 8, 2, 4, 9,12,12,10),
		    ring1( 2, 5, 6, 6, 5, 2, 5, 6),
		    ring2( 0, 0, 3, 3, 3, 3, 3, 3),
		      pal(   33,   37,   38,   35), basecol(0,255,127)},
    { 28.0f,  5.0f, blend( 8, 1, 2, 7, 7,12,12, 6),
		    ring1( 2, 6,12,13,12, 2, 2,12),
		    ring2( 0, 0, 0,12,13, 4, 4,13),
		      pal(   37,   30,   32,   36), basecol(0,255,255)},
    { 18.0f, 10.0f, blend( 0, 0, 2, 4, 6, 8,10,12),
		    ring1( 2, 2, 2, 2, 2,14, 2, 2),
		    ring2( 0, 0, 0, 0, 0, 0, 0, 0),
		      pal(   39,   32,   34,   37), basecol(0,127,255)},
    { 18.0f, 13.0f, blend( 0, 0, 0, 0, 0, 0, 0, 0),
		    ring1(15,15,15,15,15,15,15,15),
		    ring2( 0, 0, 0, 0, 0, 0, 0, 0),
		      pal(   34,   31,   36,   30), basecol(0,0,255)},
    {  6.0f, 20.0f, blend( 0, 0, 0, 0, 0, 4, 4, 8),
		    ring1(15,15,15,15,15,15,15,15),
		    ring2( 0, 0, 0, 0, 0,14,14,14),
		      pal(   38,   35,   39,   33), basecol(127,0,255)},
    {  0.0f, 15.0f, blend( 8,12, 0, 5, 5, 0, 0, 0),
		    ring1(15,15, 2, 2, 6, 6, 5, 5),
		    ring2(14,14, 4, 4, 4, 4, 4, 4),
		      pal(   36,   37,   32,   35), basecol(255,0,255)},
    { -5.0f, 13.0f, blend(10,10, 0, 0, 0,15,15, 0),
		    ring1( 6, 2, 2, 5, 2, 2, 5, 2),
		    ring2( 3, 3, 4, 4, 4, 4, 4, 4),
		      pal(   39,   31,   36,   38), basecol(255,0,255)},
    {-10.0f,  3.0f, blend( 0, 0, 0, 0, 0, 4, 8,12),
		    ring1( 2, 2, 5, 2, 5, 2, 6, 2),
		    ring2( 4, 4, 4, 4, 0, 0, 0, 0),
		      pal(   31,   34,   33,   30), basecol(255,127,255)},
    {  2.0f, 10.0f, blend( 2, 2, 2, 2, 2, 2, 2, 2),
		    ring1(12,12,12,12,12,12,12,12),
		    ring2( 2, 5, 2, 6, 2,14, 2, 2),
		      pal(   39,   31,   34,   36), basecol(255,255,255)},
    { -6.0f,  5.0f, blend( 4, 7, 5, 4, 6, 3, 2, 5),
		    ring1(10,10,10,10,10,10,10,10),
		    ring2( 2, 5, 6, 4, 6, 4, 2, 5),
		      pal(   30,   38,   33,   35), basecol(255,255,127)},
    {  0.0f,  3.0f, blend( 0, 2, 4, 6, 8,10,12,14),
		    ring1(10,10,10,10,10,10,10,10),
		    ring2(11,11,11,11,11,11,11,11),
		      pal(   34,   37,   32,   36), basecol(255,127,127)},
    { 20.0f,  0.0f, blend( 5, 5, 5, 5, 5, 5, 5, 5),
		    ring1(11,11,11,11,11,11,11,11),
		    ring2( 2, 5, 6,13, 8, 9,14, 5),
		      pal(    1,    0,    9,    8), basecol(255,127,0)},
    { 40.0f,  0.0f, blend( 4, 4, 4, 4, 8, 8, 4, 4),
		    ring1(13,13,13,13,13,13,13,13),
		    ring2( 6, 4, 2, 5, 3, 3, 5, 6),
		      pal(    7,    6,    5,    4), basecol(255,64,0)},
    { 55.0f,  5.0f, blend( 5, 6, 7, 7, 6, 5, 5, 7),
		    ring1( 8, 8, 8, 8, 8, 8, 8, 8),
		    ring2( 5, 2, 6, 2, 2, 5, 5, 6),
		      pal(    3,    2,    1,    0), basecol(127,64,0)},
    { 60.0f, 20.0f, blend( 6, 5, 7, 8, 4, 6, 6, 8),
		    ring1( 7, 7, 7, 7, 7, 7, 7, 7),
		    ring2( 6, 5, 2, 5, 2, 6, 6, 2),
		      pal(    1,    2,    3,    4), basecol(127,0,0)},
    { 60.0f, 40.0f, blend( 5, 6, 5, 3, 5, 6, 7, 8),
		    ring1(12,12,12,12,12,12,12,12),
		    ring2( 2, 5, 2, 6, 2, 6, 5, 6),
		      pal(    5,    6,    7,    8), basecol(127,0,64)},
    { 55.0f, 55.0f, blend( 0, 2, 4, 8, 4, 2, 0, 0),
		    ring1( 2, 2, 2, 2, 2, 2, 2, 2),
		    ring2(14,14,14,14,14,14,14,14),
		      pal(    9,    0,    1,    0), basecol(127,0,127)},
    { 40.0f, 60.0f, blend( 6, 5, 3, 5, 7, 3, 4, 5),
		    ring1( 2, 2, 2, 2, 2, 2, 2, 2),
		    ring2(13, 5, 6,12, 6, 5,11,10),
		      pal(    2,    3,    4,    5), basecol(64,0,127)},
    { 20.0f, 60.0f, blend( 6, 6, 0, 0,10,10, 0, 0),
		    ring1( 2, 6, 5, 5, 6, 5, 2, 6),
		    ring2( 3, 3, 0, 0, 4, 4, 0, 0),
		      pal(    6,    7,    7,    7), basecol(64,64,127)},
    {  5.0f, 55.0f, blend( 8, 8, 0, 0,12,12, 0, 0),
		    ring1( 2, 5, 6, 2, 5, 6, 2, 5),
		    ring2( 3, 3, 0, 0, 4, 4, 0, 0),
		      pal(    7,    7,    2,    2), basecol(0,64,127)},
    {  0.0f, 40.0f, blend(11,11, 0, 0, 6, 6, 0, 0),
		    ring1( 2, 5, 6, 6, 2, 5, 6, 2),
		    ring2( 3, 3, 0, 0, 4, 4, 0, 0),
		      pal(    2,    2,    7,    7), basecol(0,64,192)},
    {  5.0f, 20.0f, blend(11,11, 0, 0,10,10, 0, 0),
		    ring1( 2, 5, 6, 6, 2, 6, 5, 2),
		    ring2( 3, 3, 0, 0, 4, 4, 0, 0),
		      pal(    7,    7,    2,    2), basecol(0,192,255)},
    { 12.0f,  0.0f, blend( 9, 9, 0, 0, 7, 7, 0, 0),
		    ring1( 6, 5, 5, 2, 5, 2, 6, 6),
		    ring2( 3, 3, 0, 0, 4, 4, 0, 0),
		      pal(    1,   34,   37,   33), basecol(64,192,255)},
    {  4.0f, 10.0f, blend(13,10, 8, 7, 7, 8, 9,12),
		    ring1( 7, 7, 7, 7, 7, 7, 7, 7),
		    ring2( 5, 6, 2, 6, 5, 2, 5, 6),
		      pal(   35,   31,   39,   32), basecol(64,255,64)},
    {-13.0f, 25.0f, blend( 8, 5, 6, 8, 9,10,12,13),
		    ring1( 7, 7, 7, 7, 7, 7, 7, 7),
		    ring2( 5, 2, 2, 6, 5, 6, 2, 5),
		      pal(   30,   35,   32,   38), basecol(192,255,0)},
    { -1.0f, 20.0f, blend( 6, 5, 5, 5, 5, 5, 5, 5),
		    ring1(12,12,12,12,12,12,12,12),
		    ring2( 1, 6, 5, 4, 4, 6, 2, 5),
		      pal(   31,   36,   33,   36), basecol(255,192,0)},
    { 15.0f, 10.0f, blend( 7, 3, 6, 5, 7, 2, 6, 5),
		    ring1( 2, 2, 2, 2, 2, 2, 2, 2),
		    ring2( 5, 6, 6, 5, 6, 5, 5, 6),
		      pal(   38,   30,   37,   34), basecol(255,128,0)},
    {  2.0f,  5.0f, blend( 6, 3, 7, 8, 2, 4, 6, 4),
		    ring1( 2, 5, 6, 5, 2, 6, 2, 5),
		    ring2( 8, 8, 4, 3, 1, 2,14,10),
		      pal(   68,   63,   60,   65), basecol(0,128,0)},
    { 10.0f, 15.0f, blend( 3, 6, 3, 7, 4, 5, 3, 4),
		    ring1( 6, 5, 2, 5, 6, 5, 2, 6),
		    ring2(10, 9, 9,14,13,11, 0, 2),
		      pal(   64,   61,   66,   63), basecol(0,128,128)},
    { 10.0f, 10.0f, blend( 3, 3, 0, 6, 6, 0, 9, 9),
		    ring1( 2, 2, 2, 2, 2, 2, 2, 2),
		    ring2( 4, 4, 0, 4, 4, 0, 4, 4),
		      pal(   69,   66,   68,   60), basecol(0,0,255)},
    { -2.0f, 20.0f, blend( 0, 2, 3, 5, 4, 7,10,13),
		    ring1( 2, 2, 2, 2, 2, 2, 2, 2),
		    ring2( 0,14, 1, 1,10,10,10,10),
		      pal(   64,   62,   61,   67), basecol(127,127,255)},
    { -4.0f, 23.0f, blend( 1, 4, 7,10,13, 3, 5, 6),
		    ring1(10,10,10,10,10,12,12,12),
		    ring2(12,12,12,12,12, 5, 6, 5),
		      pal(   67,   65,   69,   62), basecol(127,255,255)},
    {  6.0f, 10.0f, blend( 5, 7, 6, 7, 7, 6, 5, 6),
		    ring1(12,12,12,12,12,12,12,12),
		    ring2( 2, 6, 3, 3, 2, 5, 6, 5),
		      pal(   30,   31,   37,   34), basecol(127,255,127)},
    {  5.0f, 14.0f, blend( 4, 7,10,13, 1, 2, 2, 1),
		    ring1(12,12,12,12,11,11,11,11),
		    ring2(11,11,11,11, 6, 2, 5, 6),
		      pal(   33,   36,   32,   35), basecol(255,255,127)},
    {  3.0f, 18.0f, blend( 8, 8, 0, 0, 0, 8, 8, 0),
		    ring1(11,11,11,11,11,11,11,11),
		    ring2( 3, 3, 0, 0, 0, 4, 4, 0),
		      pal(   61,   60,   67,   62), basecol(255,127,127)},
    {  2.0f, 22.0f, blend( 0, 0, 8, 8, 0, 0, 0, 0),
		    ring1(11,11,11,11,11,11,11,11),
		    ring2( 0, 0, 3, 3, 0, 0, 0, 0),
		      pal(   64,   65,   63,   66), basecol(255,127,255)},
    {  0.0f, 27.0f, blend(12, 8, 4, 0, 2, 4, 6, 8),
		    ring1( 2, 5, 2, 6, 5, 2, 6, 2),
		    ring2(11,11,11, 9, 9, 9, 9, 9),
		      pal(   32,   34,   36,   35), basecol(255,127,127)},
    {  0.0f, 30.0f, blend( 9,10,11,10, 8, 5, 6, 4),
		    ring1( 2, 5, 6, 2, 6, 5, 6, 2),
		    ring2( 9, 9, 9, 9, 9, 9, 9, 9),
		      pal(   31,   30,   33,   37), basecol(255,0,0)},
    {  4.0f, 12.0f, blend( 7, 4, 7, 8,12, 9,12, 3),
		    ring1( 6, 5, 2, 6, 5, 6, 2, 2),
		    ring2( 9, 9, 9, 9, 9, 9, 9, 9),
		      pal(    0,    1,    2,    3), basecol(255,255,0)},
    {  2.0f,  6.0f, blend( 9,11,12,10, 9,11,13,15),
		    ring1( 5, 6, 5, 6, 2, 2, 2, 2),
		    ring2( 9, 9, 9, 9, 9, 9, 9, 9),
		      pal(    4,    5,    6,    0), basecol(0,255,0)},
    {  0.0f,  0.0f, blend( 0, 0, 0, 0, 0, 0, 0, 0),
		    ring1( 0, 0, 0, 0, 0, 0, 0, 0),
		    ring2( 0, 0, 0, 0, 0, 0, 0, 0),
		      pal(    0,    0,    0,    0), basecol(0,0,0)},
};

