
; RENDER 


;	temporary area saves some data..

PEEWEE_TRI_AT_ONCE	.equ	28		; unlikely number - to be changed!
PEEWEE_TRI_AT_ONCE3	.equ	84		; decode 7 at once
PEEWEE_TRI_AT_ONCE4	.equ	7		; decode 7 at once
PEEWEE_NUM_TRI		.equ	588		; uh-oh!







	gs_send_reg_init

;*****************************************************************************
;
;	TODO - set other registers here!
;
;*****************************************************************************

;*****************************************************************************
;	lets turn the zbuffer and the frame buffers on
;	now - we're going to test
; 	configure the texture system
;*****************************************************************************

	--barrier		

	gs_send_sync
	
	loiPLUSxy		tst,0z00050000,0
	gs_sendreg_vf		GS_TEST_1,tst



	gs_send_sync

	--barrier

	gs_sendreg_imm		GS_TEX1_1,96		; mip setting
	gs_send_sync

	--barrier

	loiMINxy		tex,LONG_TEX_TX0PEEWEE_LO,LONG_TEX_TX0PEEWEE_HI

	gs_sendreg_vf		GS_TEX0_1,tex
	gs_send_sync
	
	--barrier

	gs_kick_addr		i_pw1Tag	; kick to start off strips
	gs_send_sync

	--barrier



;*****************************************************************************
;	TODO - change ntri to model value!
;*****************************************************************************

	isetiu		strip_decode_ptr,i_peeweeData+1
	isetiu		nTri,PEEWEE_NUM_TRI	

;*****************************************************************************
;	TODO -set up giftag ok
; 	this should be ok for now
;*****************************************************************************

	--barrier
	lq		gtag,i_pw2Tag(vi00)
	isetiu		outBuffer,p_outBuffer

	isetiu		nloop,PEEWEE_TRI_AT_ONCE+1
	iaddiu		nloop,nloop,0x7fff 		; to force eop

	isw.x		nloop,(outBuffer)
	sq.yzw		gtag,(outBuffer)	; fixme
	--barrier



;*****************************************************************************
;	so - onto the renderin..
;*****************************************************************************



tri_loop:

;****************************************************
;
;	extract the encoded tristrip commands
;	to local buffer at PEEWEE_SCMD_BASE
;
;****************************************************

	isetiu		scmd_ptr,p_pwSCMD				; where to decode to
	isetiu		scmd_end,p_pwSCMD+PEEWEE_TRI_AT_ONCE		; end of local buffer

sdec_loop:

	ilw.y		s0,1(strip_decode_ptr)	    	; ny
	ilw.z		s1,1(strip_decode_ptr)		; nz
	ilw.w		s2,1(strip_decode_ptr)		; t
	ilw.w		s3,0(strip_decode_ptr)		; s
	

	isw.w		s0,(scmd_ptr)
	isw.w		s1,1(scmd_ptr)
	isw.w		s2,2(scmd_ptr)
	isw.w		s3,3(scmd_ptr)

	iaddiu		scmd_ptr,scmd_ptr,4						; next local command
	iaddiu		strip_decode_ptr,strip_decode_ptr,2    						; onto next tri 

	ibne		scmd_ptr,scmd_end,sdec_loop

;****************************************************
;
;	now theyre decoded - let's render them
;
;****************************************************

	isetiu		scmd_ptr,p_pwSCMD				; where to decode to
	isetiu		scmd_end,p_pwSCMD+PEEWEE_TRI_AT_ONCE		; end of local buffer

	iaddiu		out_p,outBuffer,1					; out buffer
	iaddiu		end_p,out_p,PEEWEE_TRI_AT_ONCE3				; end of out buffer

	isetiu		adcmask,0x200
	isetiu		vrtmask,0x1ff
	isetiu		cidmask,0x1f

	loi		2048

	lq		camc,d_camLocal(vi00)
	add.xy		gsCentre,vf00,i
	move.z		gsCentre,vf00


	loi		10.0
	add.xyz		tmp,vf00,i
	mul.w		tmp,vf00,i
	mul		tmp,tmp,tmp
	mul		tmp,tmp,tmp
	mul.w		tmp,tmp,tmp
	mul.w		tmp,tmp,tmp



				  
	loixyzw		lConst1,128.0,128.0,128.0,255.0
	loixyzw		amby,32,32,32,0
	
	mul		lConst1,lConst1,tmp

	
	; clipping + guard band

   	loi		-512.299988
   	add.z		clipAdd,vf00,i	       			; I really don't remember the near clip being quite so close..
   	loixyzw		clipMul,1.941e-3,6.962e-3,1.954e-3,1  	; oh man, magic numbers!

   	

	fcset		0

	loi		255.0
	--barrier
	gs_send_sync

strip_loop:

	--loopcs	3,3
	--loopextra	1		; without this , assembles to 1 cycle faster with ldumb, but takes a while to get there..

	ilw.w		scmd,(scmd_ptr)
	iand		adcbit,scmd,adcmask
	iand		vrtea,scmd,vrtmask
	iadd		vrtea,vrtea,vrtea
	
	lq		vxyzs,i_peeweeData+1(vrtea)
	lq		nxyzt,i_peeweeData+2(vrtea)
	ilw.x		cid,  i_peeweeData+2(vrtea)x  ; nx is cid
	
	iand		cid,cid,cidmask
	iadd		cid,cid,cid
	iadd		cid,cid,cid

	lq.xyz		o2c[0],p_pwCID+0(cid)
	lq.xyz		o2c[1],p_pwCID+1(cid)
	lq.xyz		o2c[2],p_pwCID+2(cid)
	lq.xyz		o2c[3],p_pwCID+3(cid)
	
		
	mul.xyz		acc,o2c[0],vxyzs[x]
	madd.xyz	acc,o2c[1],vxyzs[y]
	madd.xyz	acc,o2c[2],vxyzs[z]
	madd.xyz	saloc,o2c[3],vf00[w]


	; sloc is in camera space - so..

	mul.xy		sloc,saloc,camc		; -Sxh,-SxH
	adda.z		acc,vf00,camc[z]	; A
	madd.z		sloc,saloc,camc[w]  	; Bz+A

	div		q,vf00[w],saloc[z]
	mul.xyz		tloc,sloc,q
	add.xyz		gloc,tloc,gsCentre
	ftoi4.xyz	gloc,gloc
	sq.xyz		gloc,2(out_p)



;	tloc is the thing to clip .. lordy, im soooo tired..
	add.z		tloc,clipAdd,saloc
	mul.xyz		clipVrt,clipMul,tloc
	clipw.xyz	clipVrt,vf00
	fcand		vi01,0x3fff	 	  		; only care about previous vertex
	ior		adcbit,adcbit,vi01

	iaddiu		adcbit,adcbit,0x7fff
	isw.w		adcbit,2(out_p)

;	set stq

	mr32.z		mstq,vf00
	add.x		mstq,vf00,vxyzs[w]
	mr32		tmp,nxyzt
	mr32.y		mstq,tmp
	mul.xyz		mstq,mstq,q
	sq.xyz		mstq,0(out_p)

; a lighty blub

	mul.xyz		acc,o2c[0],nxyzt[x]
	madd.xyz	acc,o2c[1],nxyzt[y]
	madd.xyz	light,o2c[2],nxyzt[z]
	
	
	add.xyz		rgba,vf00,light[x]
	mul.w		rgba,vf00,light[y]
	
	mul.xyzw	rgba,rgba,rgba
	mul.xyzw	rgba,rgba,rgba
	mul.w		rgba,rgba,rgba
	mul.w		rgba,rgba,rgba

	mul	  	acc,rgba,lConst1		; diffuse 128 don't need this roll it back
	madd	     	rgba,amby,vf00[w] 		; ambient  32
	
	mini		rgba,rgba,i
	ftoi0		rgba,rgba

	sq		rgba,1(out_p)


	iaddiu		scmd_ptr,scmd_ptr,1		; advance scmd ptr
	iaddiu		out_p,out_p,3			; prim_size
	ibne		out_p,end_p,strip_loop


	xgkick		outBuffer

	isubiu		nTri,nTri,PEEWEE_TRI_AT_ONCE
	ibne		nTri,vi00,tri_loop


	gs_send_sync



